#include <stdlib.h>
#include <openssl/bio.h>

#include "utfutils.h"
#include "runtime.h"

int BIO_puts16(BIO *b, const char *buf)
{
   int ret = 0;
   char *tmp = NULL;

   if(!buf) return -1;

   while(buf[0]) {
      if((buf[0] & 0xC0) == 0x80) {
         if(tmp) free(tmp);
         return -1;
      } else if((buf[0] & 0x80) == 0x00) {
         ret += 2;
         if(!(tmp = realloc(tmp, ret))) return -1;
         tmp[ret - 1] = '\0';
         tmp[ret - 2] = buf[0];
         buf++;
      } else if(((buf[0] & 0xE0) == 0xC0) && ((buf[1] & 0xC0) == 0x80)) {
         ret += 2;
         if(!(tmp = realloc(tmp, ret))) return -1;
         tmp[ret - 1] = (buf[0]>>2) & 0x07;
         tmp[ret - 2] = ((buf[0] & 0x03)<<6) | (buf[1] & 0x3F);
         buf += 2;
      } else if(((buf[0] & 0xF0) == 0xE0) && ((buf[1] & 0xC0) == 0x80) && ((buf[2] & 0xC0) == 0x80)) {
         ret += 2;
         if(!(tmp = realloc(tmp, ret))) return -1;
         tmp[ret - 1] = ((buf[0] & 0x0F)<<4) | ((buf[1]>>1) & 0x0F);
         tmp[ret - 2] = ((buf[1] & 0x01)<<7) | (buf[2] & 0x3F);
         buf += 3;
      } else {
         if(tmp) free(tmp);
         return -1;
      }
   }
   
   ret = (BIO_write(b, tmp, ret) == ret) ? 0 : -1;

   free(tmp);

   return ret;
}

int strlen16(const char *buf)
{
   int ret = 0;

   if(!buf) return -1;

   while(buf[0]) {
      if((buf[0] & 0xC0) == 0x80) {
         return -1;
      } else if((buf[0] & 0x80) == 0x00) {
         ret += 2;
         buf++;
      } else if(((buf[0] & 0xE0) == 0xC0) && ((buf[1] & 0xC0) == 0x80)) {
         ret += 2;
         buf += 2;
      } else if(((buf[0] & 0xF0) == 0xE0) && ((buf[1] & 0xC0) == 0x80) && ((buf[2] & 0xC0) == 0x80)) {
         ret += 2;
         buf += 3;
      } else {
         return -1;
      }
   }
   
   return ret;
}
